xquery version "3.1";
(:
 : For LICENSE-Details please refer to the LICENSE file in the root directory of this repository.
 :)

(: NAMESPACE DECLARATIONS ================================================== :)

declare namespace mei = "http://www.music-encoding.org/ns/mei";
declare namespace output = "http://www.w3.org/2010/xslt-xquery-serialization";
declare namespace request = "http://exist-db.org/xquery/request";
declare namespace xlink = "http://www.w3.org/1999/xlink";
declare namespace xmldb = "http://exist-db.org/xquery/xmldb";

(: OPTION DECLARATIONS ===================================================== :)

declare option output:method "json";
declare option output:media-type "application/json";

(: QUERY BODY ============================================================== :)

let $uri := request:get-parameter('uri', '')
let $mei := doc($uri)

let $movements as array(*)* :=
    array {
        for $movement in $mei//mei:mdiv
        return
            map {
                'id': $movement/string(@xml:id),
                'name': $movement/string(@label),
                'parts': array {
                    for $part in $movement//mei:part
                    return
                        map {
                            'id': $part/string(@xml:id),
                            'name': $part/string(@label)
                        }
                }

        }
    }

return
    $movements
